/*   
 *   copyright: Steve Dekorte, 2002. All rights reserved.
 *   license: See _BSDLicense.txt.
 *
 * Basic command line interace with input callback
 */
 
#ifndef CLI_DEFINED
#define CLI_DEFINED 1

#include "Common.h"
#include "ByteArray.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (CLICallback)(void *target, char *);
typedef void (CLIInputFunction)(void *handler);

typedef struct
{
    ByteArray *buffer;
    int eof;
    void *target;
    char *prompt;
    CLICallback *callback; /* callback to owner upon input */
    void *inputHandler;
    CLIInputFunction *inputFunction;
    int done;
} CLI;

CLI *CLI_new(void);
void CLI_free(CLI *self);

void CLI_prompt_(CLI *self, char *s);
void CLI_target_callback_(CLI *self, void *target, CLICallback *callback);

void CLI_input(CLI *self);
int CLI_eof(CLI *self);
void CLI_run(CLI *self);
void CLI_exit(CLI *self);

#ifdef __cplusplus
}
#endif
#endif
